/* Segment #3: begin of video RAM for a B/W machine*/
unsigned short *screen = (unsigned short *)0x3000000;

#define SCREEN_WIDTH    512
#define SCREEN_HEIGHT   256
#define SCREEN_SIZE     (SCREEN_WIDTH / 16 * SCREEN_HEIGHT)   /* words */
#define ABS(a) ((a)>0 ? (a):(-a))
#define MAX(a,b) (((a)>(b))? (a):(b))
#define SIGN(a) ((a)>0 ? 1 : ((a)==0 ? 0 : (-1)))
#define TRUE -1
#define FALSE 0

/*  Fills the screen memory with a defined word. */
void fillscr(unsigned short p)
{
    unsigned short *s;
    for (s=screen; s < screen+SCREEN_SIZE; ++s)
        *s = p;
}

/*  Just turn on a pixel by accessing directly to the video RAM. */
#define PSET_M(x,y) *(screen + (((y)<<5) | ((x)>>4)))|=1<<(15-((x) & 0x000F))

/*  Plot a line using the Bresenham algorithm.
    from Nelson Johnson, "Advanced Graphics in C"
    ed. Osborne, McGraw-Hill 1987. */
void line(unsigned short x1, unsigned short y1, 
    unsigned short x2, unsigned short y2)
{
    short dx=x2-x1, dy=y2-y1;
    short ix=ABS(dx), iy=ABS(dy);
    short inc=MAX(ix, iy), plotx=x1, ploty=y1, i, plot;
    short x=0, y=0;

    PSET_M(plotx,ploty);  /* Plot the first pixel */
    for(i=0; i<=inc; ++i) {
        x += ix;
        y += iy;
        plot=FALSE;
        if (x>inc) {
            plot=TRUE;
            x-=inc;
            plotx+=SIGN(dx);
        }
        if (y>inc) {
            plot=TRUE;
            y-=inc;
            ploty+=SIGN(dy);
        }
        if (plot)
            PSET_M(plotx,ploty);
    }
}

int main(int argc, char **argv)
{
    int i;
    fillscr(0);
    for (i=0; i<512; i+=10) {
        line(0,0,i,128);
        line(0,255,i,128);
        line(511,255,i,128);
        line(511,0,i,128);
    }
    return 0;
}

